Bug 44322 - mod_proxy ProxyPassReverseCookieDomain with no domain set in cookie cannot set a domain
Summary: mod_proxy ProxyPassReverseCookieDomain with no domain set in cookie cannot se...
Status: RESOLVED LATER
Alias: None
Product: Apache httpd-2
Classification: Unclassified
Component: mod_proxy (show other bugs)
Version: 2.2.6
Hardware: All Linux
: P2 enhancement with 2 votes (vote)
Target Milestone: ---
Assignee: Apache HTTPD Bugs Mailing List
URL:
Keywords: MassUpdate
Depends on:
Blocks:
 
Reported: 2008-01-29 12:39 UTC by regilero
Modified: 2018-11-07 21:08 UTC (History)
2 users (show)



Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description regilero 2008-01-29 12:39:22 UTC
On a reverse proxy we want to force cookie domain:
--------------------------------------------------
ProxyPass       /       http://www1.foo.com/bar/
ProxyPassReverse /      http://www1.foo.com/bar/
ProxyPassReverseCookieDomain www1.foo.com .foo.com
----------------------------------------------------
It works, ProxyPassReverseCookieDomain permits us to rewrite the cookie as a
'domain valid' cookie for -bad- applications that cannot do it on their own.

But When such applications aren't setting any domain information on the cookie
we cannot enforce the cookie domain. This cookie domain is empty and so browsers
interpret it as the host name (here the proxy public name). Bad.
lets say we should be able to write:
ProxyPassReverseCookieDomain "" ".foo.com"
or 
ProxyPassReverseCookieDomain NULL .foo.com
It's not possible

Workaround: Actually we handle this situation by injection Cookie Domain in
Cookie path rewriting that way:
ProxyPassReverseCookiePath / "/; Domain=.foo.com"
And it works, but that's piggy.
Comment 1 Bill McGonigle 2010-07-14 17:51:12 UTC
This came up for me today with Tomcat's JSESSIONID which sets a path but not a domain.

This is a sick, twisted, and clever work-around from Jason Butler:

Header edit Set-Cookie "(JSESSIONID\s?=[^;,]+?)((?:;\s?(?:(?i)Comment|Max-Age|Path|Version|Secure)[^;,]*?)*)(;\s?(?:(?i)Domain\s?=)[^;,]+?)?((?:;\s?(?:(?i)Comment|Max-Age|Path|Version|Secure)[^;,]*?)*)(,|$)" "$1$2; Domain=.example.com$4$5"

but it would be better to have native support for this.  I'd prefer the NULL magic word approach.
Comment 2 William A. Rowe Jr. 2018-11-07 21:08:10 UTC
Please help us to refine our list of open and current defects; this is a mass update of old and inactive Bugzilla reports which reflect user error, already resolved defects, and still-existing defects in httpd.

As repeatedly announced, the Apache HTTP Server Project has discontinued all development and patch review of the 2.2.x series of releases. The final release 2.2.34 was published in July 2017, and no further evaluation of bug reports or security risks will be considered or published for 2.2.x releases. All reports older than 2.4.x have been updated to status RESOLVED/LATER; no further action is expected unless the report still applies to a current version of httpd.

If your report represented a question or confusion about how to use an httpd feature, an unexpected server behavior, problems building or installing httpd, or working with an external component (a third party module, browser etc.) we ask you to start by bringing your question to the User Support and Discussion mailing list, see [https://httpd.apache.org/lists.html#http-users] for details. Include a link to this Bugzilla report for completeness with your question.

If your report was clearly a defect in httpd or a feature request, we ask that you retest using a modern httpd release (2.4.33 or later) released in the past year. If it can be reproduced, please reopen this bug and change the Version field above to the httpd version you have reconfirmed with.

Your help in identifying defects or enhancements still applicable to the current httpd server software release is greatly appreciated.